package com.zxhy.hfilemanagermaster.internalstorage

import android.annotation.SuppressLint
import android.content.Context
import android.view.View
import android.view.ViewGroup
import androidx.recyclerview.widget.RecyclerView
import com.example.hfilemanagermaster.R
import com.example.hfilemanagermaster.databinding.ItemFileSelectBinding
import com.zxhy.hfilemanagermaster.data.MediaDataC
import com.zxhy.hfilemanagermaster.glide.loadIntoImageView
import com.zxhy.hfilemanagermaster.knife.file2MediaDataC
import com.zxhy.hfilemanagermaster.knife.inflate
import java.io.File

class FileAdapter(
    private val selectAction: ((flag: Boolean) -> Unit)? = null
) : RecyclerView.Adapter<FileAdapter.FileSelectViewHolder>() {
    private val mediaList = arrayListOf<MediaDataC>()
    private var isSelect = false

    class FileSelectViewHolder(view: View) : RecyclerView.ViewHolder(view) {
        val binding = ItemFileSelectBinding.bind(view)
    }

    override fun onCreateViewHolder(
        parent: ViewGroup,
        viewType: Int
    ): FileSelectViewHolder {
        val root = R.layout.item_file_select.inflate(parent)
        return FileSelectViewHolder(root)
    }

    override fun getItemCount(): Int {
        return mediaList.size
    }

    override fun onBindViewHolder(holder: FileSelectViewHolder, position: Int) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        holder.binding.apply {
            if (data.path.contains(".jpg")
                or
                data.path.contains(".mp4")
                or
                data.path.contains(".png")
            ) {
                loadIntoImageView(context, File(data.path), iv)
            } else if (data.path.contains(".txt")) {
                iv.setImageResource(R.mipmap.io_002)
            } else if (data.path.contains(".xlsx") or data.path.contains(".xls")) {
                iv.setImageResource(R.mipmap.as_85230)
            } else if (data.path.contains(".pdf")) {
                iv.setImageResource(R.mipmap.io_0012)
            } else if (data.path.contains(".ppt") or data.path.contains(".pptx")) {
                iv.setImageResource(R.mipmap.io_002223)
            } else {
                iv.setImageResource(R.mipmap.tt_695)
            }

            tvName.text = data.name
            tvSize.text = data.size
            ivSelector.isSelected = data.select
            flSelector.setOnClickListener {
                data.select = !data.select
                notifyItemChanged(position, "单条刷新")
            }
            ivSelector.visibility = if (isSelect) View.VISIBLE else View.GONE

            if (data == mediaList.last()) {
                selectAction?.invoke(mediaList.all { it.select })
            }
            root.setOnClickListener {
                nextPage(data, context)
            }
        }


    }

    override fun onBindViewHolder(
        holder: FileSelectViewHolder,
        position: Int,
        payloads: MutableList<Any>
    ) {
        val context = holder.binding.root.context
        val data = mediaList[position]

        //判断是做局部刷新还是单条刷新
        if (payloads.isEmpty()) {//局部刷新
            holder.binding.apply {
                if (data.path.contains(".jpg")
                    or
                    data.path.contains(".mp4")
                    or
                    data.path.contains(".png")
                ) {
                    loadIntoImageView(context, File(data.path), iv)
                } else if (data.path.contains(".txt")) {
                    iv.setImageResource(R.mipmap.io_002)
                } else if (data.path.contains(".xlsx") or data.path.contains(".xls")) {
                    iv.setImageResource(R.mipmap.as_85230)
                } else if (data.path.contains(".pdf")) {
                    iv.setImageResource(R.mipmap.io_0012)
                } else if (data.path.contains(".ppt") or data.path.contains(".pptx")) {
                    iv.setImageResource(R.mipmap.io_002223)
                } else {
                    iv.setImageResource(R.mipmap.tt_695)
                }

                tvName.text = data.name
                tvSize.text = data.size
                ivSelector.isSelected = data.select
                flSelector.setOnClickListener {
                    data.select = !data.select
                    notifyItemChanged(position, "单条刷新")
                }
                if (data == mediaList.last()) {
                    selectAction?.invoke(mediaList.all { it.select })
                }
                root.setOnClickListener {
                    nextPage(data, context)
                }
                ivSelector.visibility = if (isSelect) View.VISIBLE else View.GONE
            }
        } else {// 单条刷新
            holder.binding.apply {
                ivSelector.isSelected = data.select
            }
            super.onBindViewHolder(holder, position, payloads)

            selectAction?.invoke(mediaList.all { it.select })
        }

    }

    @SuppressLint("NotifyDataSetChanged")
    fun setData(data: List<MediaDataC>) {
        mediaList.clear()
        mediaList.addAll(data)
        notifyDataSetChanged()
    }


    @SuppressLint("NotifyDataSetChanged")
    fun setToggleSelect(): Boolean {
        val flag = mediaList.all { it.select }
        mediaList.forEach { it.select = !flag }
        notifyDataSetChanged()
        return !flag
    }

    fun getSelectSize(): Int {
        return mediaList.count { it.select }
    }

    private fun nextPage(data: MediaDataC, context: Context) {
        val file = File(data.path)
        if (file.isDirectory) {
            val subList = file.listFiles()
            val subData = subList?.map { it.file2MediaDataC(context) } ?: listOf()
            setData(subData)
        }
    }

    fun beforePage(context: Context): Boolean {
        val file = File(mediaList.first().path).parentFile?.parentFile
        if (file != null && file.exists()) {
            if (file.isDirectory) {
                val subList = file.listFiles()
                if (subList.isNullOrEmpty()) return false
                val subData = subList.map { it.file2MediaDataC(context) }
                setData(subData)
            }
            return true
        } else {
            return false
        }
    }

    @SuppressLint("NotifyDataSetChanged")
    fun showSelect() {
        isSelect = true
        notifyDataSetChanged()
    }

    @SuppressLint("NotifyDataSetChanged")
    fun showNoSelect() {
        isSelect = false
        notifyDataSetChanged()
    }
}